﻿/*
	Clase:						dibujar
	Descripción:				Clase usadada por objeto3d para realizar el dibujo final de los puntos espaciales
	Autor:						Gerson Montenegro
	E-mail:						gersonmontenegro@gmail.com
	Fecha última modificación:	18.05.2k5
	Licencia:					GNU/GPL
*/
import clases.operaciones;
class clases.dibujar{
	var rotarPrototipo:Object = new Object();
	var clickeado:Boolean = new Boolean();
	var dibujado_bln:Boolean = new Boolean();
	var rotando_bln:Boolean = new Boolean();
	var p_array:Array = new Array();
	var e_array:Array = new Array();
	var dibujar_mc;
	var movie_mc;

	function dibujar(puntos_array:Array, enlaces_array:Array, _rotarPrototipo:Object, objeto_mc:MovieClip){
		objeto_mc.clickeado = false;
		objeto_mc.dibujado_bln = false;
		objeto_mc.p_array = new Array();
		objeto_mc.e_array = new Array();
		objeto_mc.rotarPrototipo = new Object();
		objeto_mc.rotarPrototipo = _rotarPrototipo;
		objeto_mc.p_array = puntos_array;
		objeto_mc.e_array = enlaces_array;
		objeto_mc.movie_mc = new MovieClip();
		objeto_mc.primera = false;
		
		objeto_mc.onEnterFrame = function(){
			var oBasicas:operaciones = new operaciones();
			if(this.rotando_bln == true){
				var screenPoints = oBasicas.crearProyeccionEnPantallaTrasladado(this.p_array, "x", .1);
			}else{
				var screenPoints = oBasicas.crearProyeccionEnPantalla(this.p_array, rotarPrototipo);
			}
			var enlaces, v;
			var vertices_array:Array = new Array();
			if(dibujado_bln == false){
				dibujado_bln = true;
				//trace("dibujando...");
				for(enlaces in this.e_array){
					vertices_array = this.e_array[enlaces].toString().split(",");
					this["pared_" + enlaces].clear();
					this.createEmptyMovieClip("pared_" + enlaces, (10000 - enlaces));
					if(this.pintarLineas == 1){
						this["pared_" + enlaces].lineStyle(.1, 0x000000, 50);
					}else{
						this["pared_" + enlaces].lineStyle(0, 0x000000, 0);
					}
					//trace(this.miColor);
					this["pared_" + enlaces].beginFill(this.miColor, 20);
					this["pared_" + enlaces].moveTo(screenPoints[vertices_array[0]].x, screenPoints[vertices_array[0]].y);
					for(v = 0; v < vertices_array.length; v ++){
						this["pared_" + enlaces].lineTo(screenPoints[vertices_array[v]].x, screenPoints[vertices_array[v]].y);
					}
					this["pared_" + enlaces].endFill();
					
				}
				//trace("Pintado: " + this.miNombre_str);//se termina la pintada
				if(this.primera == false){
					this.primera = true;
					_root.asignacion(this.miNombre_str);
				}
			}
		}
		
		rotarPrototipo = _rotarPrototipo;
	}
	
	function crearMC(ruta_mc:MovieClip, nombre_str:String, enlaces:Number){
		ruta_mc.createEmptyMovieClip(nombre_str, (10000 - enlaces));
	}

	function clicking(){
		this.clickeado = true;
	}
	function unclicking(){
		this.clickeado = false;
	}
	
	function rotateCube() {
			var oBasicas:operaciones = new operaciones();
			if(this.rotando_bln == true){
				var screenPoints = oBasicas.crearProyeccionEnPantallaTrasladado(this.p_array, "x", .1);
			}else{
				var screenPoints = oBasicas.crearProyeccionEnPantalla(this.p_array, rotarPrototipo);
			}
			
			this["pared_" + enlaces].clear();
			//this["pared_" + enlaces].lineStyle(1, 0x0000ff, 50);
			var enlaces, v;
			var vertices_array:Array = new Array();
			var dibujar_mc:MovieClip = new MovieClip();
			for(enlaces in this.e_array){
				vertices_array = this.e_array[enlaces].toString().split(",");

				//crearMC(this, "pared_" + enlaces, enlaces);
				dibujar_mc = this.movie_mc;
				
				this.dibujar_mc["pared_" + enlaces].lineStyle(1, 0x0000ff, 50);
				//this["pared_" + enlaces].beginFill(0x0000ff, 20);
				this["pared_" + enlaces].moveTo(screenPoints[vertices_array[0]].x, screenPoints[vertices_array[0]].y);
				for(v = 1; v < vertices_array.length; v ++){
					this.dibujar_mc["pared_" + enlaces].lineTo(screenPoints[vertices_array[v]].x, screenPoints[vertices_array[v]].y);
				}
				
				//trace(this.dibujar_mc);
				
				//this["pared_" + enlaces].endFill();
				
				/*this["pared_" + enlaces].onRollOver = function(){
					trace(this);
					//this._visible = false;
					trace("antes: " + this._x);
					this._x += 10000;
					this._y += 10000;
					trace("después: " + this._x);
				}*/
				
				/*this["pared_" + enlaces].onRelease = function(){
					this._visible = false;
					trace(this);
				}*/
			}
    }
}